Codeforces Good Bye 2015 E. New Year and Three Musketeers

题意:有三个火枪手,每个人有一个攻击力,有n个罪犯,分别有一个攻击力,三个火枪手的攻击力是可以合并,譬如三个人的攻击力分别是1,2,3,罪犯的攻击力是6,三个人就可以在一个回合内击败罪犯,题目要求击败所有的罪犯最少需要多少个回合?(每个人在一个回合中只能攻击一次或者什么事都不干)
思路:贪心,这贪心好难写的说,或许是因为我蠢。因为超过三个人中最大的就要至少两个人合力来打掉它。从小到大排序,从大于三个人中最大的开始处理,如果 a1+a2>=Ai(a1,a2Ai) 则在 <=a3 <script id="MathJax-Element-1157" type="math/tex"><=a_3</script>所有罪犯的攻击力中挑一个没有被处理过的并且最大的来处理。同理,处理到第n个罪犯。现在只剩下 cnti1 <=a1 <script id="MathJax-Element-1159" type="math/tex"><=a_1</script>的, cnti2 >=a1<=a2 的, cnti3 >=a2<=a3 的罪犯。处理这些罪犯的时候注意几点。
  • a1 能干掉的敌人, a2,a3 也能干掉。 a2 能干掉的敌人, a3 也能干掉
  • a3 能干掉的敌人,或许 a1+a2 能干掉,这种情况要特殊处理

http://codeforces.com/contest/611/problem/E

/*********************************************
    Problem : Codeforces Good Bye 2015
    Author  : NMfloat
    InkTime (c) NM . All Rights Reserved .
********************************************/

#include <map>
#include <set>
#include <queue>
#include <stack>
#include <cmath>
#include <ctime>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <iostream>
#include <algorithm>

#define rep(i,a,b)  for(int i = (a) ; i <= (b) ; i ++)
#define rrep(i,a,b) for(int i = (b) ; i >= (a) ; i --)
#define repE(p,u) for(Edge * p = G[u].first ; p ; p = p -> next)
#define cls(a,x)   memset(a,x,sizeof(a))
#define eps 1e-8

using namespace std;

const int MOD = 1e9+7;
const int INF = 0x3f3f3f3f;
const int MAXN = 1e5+5;
const int MAXE = 2e5+5;

typedef long long LL;
typedef unsigned long long ULL;

int T,n,m,k;

int fx[] = {0,1,-1,0,0};
int fy[] = {0,0,0,-1,1};

int A[200005];
int a[10];
int pos[10];
int spos[10];
int vis[200005];
int cnti[10];

void input() {
    rep(i,1,3) scanf("%d",&a[i]);
    rep(i,1,n) scanf("%d",&A[i]);
}

void Debug() {
    rep(i,1,n) printf("%d ",A[i]);
    puts("");
}

void solve() {
    sort(a+1,a+4);
    a[4] = a[1] + a[2]; a[5] = a[1] + a[3];
    a[6] = a[2] + a[3]; a[7] = a[1] + a[2] + a[3];
    sort(A+1,A+n+1);
    cls(pos,0); cls(vis,0);
    int ok = 0;
    rep(i,1,n) {
        if(A[i] > a[7]) ok = 1;
        if(A[i] <= a[1]) pos[1] = i;
        if(A[i] <= a[2]) pos[2] = i;
        if(A[i] <= a[3]) pos[3] = i;
    }
    rep(i,1,3) spos[i] = pos[i];
    if(ok) {puts("-1");return;}
    int ans = n - pos[3];
    int posi = pos[3] + 1;
    rep(i,posi,n) {
        rep(j,4,7) {
            if(A[i] <= a[j]) {
                if(j == 4) {
                    while(pos[3] && vis[pos[3]]) { pos[3] --; }
                    if(pos[3]) { vis[pos[3]] = 1; pos[3] --; }
                }
                else if(j == 5) {
                    while(pos[2] && vis[pos[2]]) { pos[2] --; }
                    if(pos[2]) { vis[pos[2]] = 1; pos[2] --; }
                }
                else if(j == 6) {
                    while(pos[1] && vis[pos[1]]) { pos[1] --; }
                    if(pos[1]) { vis[pos[1]] = 1; pos[1] --; }
                }
                break;
            }
        }
    }
    rep(i,1,3) while(pos[i] && vis[pos[i]]) { pos[i] --; }

    int count = 0;
    rep(i,spos[2]+1,pos[3]) {
        if(a[4] >= A[i]) {
            count ++;
        }
    }
    cls(cnti,0);


    cnti[1] = pos[1];
    if(pos[2] > spos[1]) cnti[2] = pos[2] - spos[1];
    if(pos[3] > spos[2]) cnti[3] = pos[3] - spos[2];
    int minnum = min(cnti[1],min(cnti[2],cnti[3]));
    ans += minnum;
    rep(i,1,3) cnti[i] -= minnum;
    int gap;
    if(cnti[1] == 0) {
        if(cnti[3] > cnti[2]) {
            gap = (cnti[3] - cnti[2]) / 2;
            gap = min(gap,count);
            ans += (cnti[3] - gap);
        }
        else ans += (cnti[2] + cnti[3] + 1) / 2;
    }
    else if(cnti[2] == 0) {
        if(cnti[3] > (cnti[1] + 1) / 2) {
            ans += (cnti[1] + 1) / 2;
            cnti[3] -= (cnti[1] + 1) / 2;
            int gap = cnti[3] / 2;
            gap = min(count,gap);
            cnti[3] -= gap;
            ans += cnti[3];
        }
        else {
            ans += (cnti[1] + cnti[3] + 2) / 3;
        } 
    }
    else {
        if(cnti[1] > ((cnti[2] + 1) / 2)) {
            ans += (cnti[1] + cnti[2] + 2) / 3; 
        }
        else {
            ans += (cnti[2] + 1) / 2;
        }
    }
    printf("%d\n",ans);
} 

int main(void) {
    //freopen("a.in","r",stdin);
    while(~scanf("%d",&n)) {
        input();
        solve();
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
提供的源码资源涵盖了小程序应用等多个领域,每个领域都包含了丰富的实例和项目。这些源码都是基于各自平台的最新技术和标准编写,确保了在对应环境下能够无缝运行。同时,源码中配备了详细的注释和文档,帮助用户快速理解代码结构和实现逻辑。 适用人群: 适合毕业设计、课程设计作业。这些源码资源特别适合大学生群体。无论你是计算机相关专业的学生,还是对其他领域编程感兴趣的学生,这些资源都能为你提供宝贵的学习和实践机会。通过学习和运行这些源码,你可以掌握各平台开发的基础知识,提升编程能力和项目实战经验。 使用场景及目标: 在学习阶段,你可以利用这些源码资源进行课程实践、课外项目或毕业设计。通过分析和运行源码,你将深入了解各平台开发的技术细节和最佳实践,逐步培养起自己的项目开发和问题解决能力。此外,在求职或创业过程中,具备跨平台开发能力的大学生将更具竞争力。 其他说明: 为了确保源码资源的可运行性和易用性,特别注意了以下几点:首先,每份源码都提供了详细的运行环境和依赖说明,确保用户能够轻松搭建起开发环境;其次,源码中的注释和文档都非常完善,方便用户快速上手和理解代码;最后,我会定期更新这些源码资源,以适应各平台技术的最新发展和市场需求。 所有源码均经过严格测试,可以直接运行,可以放心下载使用。有任何使用问题欢迎随时与博主沟通,第一时间进行解答!

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值